# Define the kmod package name here.
%define kmod_name wl

# Define the Broadcom tarball name here.
%define bcom_name hybrid-portsrc

# If kversion isn't defined on the rpmbuild line, define it here as the currently running kernel.
%{!?kversion: %define kversion $(uname -r)}

Name:    %{kmod_name}-kmod
Version: 5_100_82_112
Release: 1.el6%{?dist}
Group:   System Environment/Kernel
License: Broadcom
Summary: %{kmod_name} kernel module(s)
URL:     http://www.broadcom.com/support/802.11/linux_sta.php

BuildRequires: redhat-rpm-config
ExclusiveArch: i686 x86_64

# Sources.
Source0:  %{bcom_name}_x86_32-v%{version}.tar.gz
Source1:  %{bcom_name}_x86_64-v%{version}.tar.gz
Source2:  README.txt
Source10: kmodtool-%{kmod_name}-el6.sh
Source15: ELRepo-%{kmod_name}-makefile

# Ensure that the proprietary tarballs ARE NOT packaged.
NoSource: 0
NoSource: 1

# Magic hidden here.
%{expand:%(sh %{SOURCE10} rpmtemplate %{kmod_name} %{kversion} "")}

# Disable the building of the debug package(s).
%define debug_package %{nil}

%description
This package provides the Broadcom hybrid %{kmod_name} kernel module(s).
It is built to depend upon the specific ABI provided by a range of releases
of the same variant of the Linux kernel and not on any one specific build.

%prep
%setup -q -n %{kmod_name}-kmod-%{version} -c -T
%ifarch i686
%setup -q -D -T -a 0
%endif
%ifarch x86_64
%setup -q -D -T -a 1
%endif
%{__cp} -a %{SOURCE2} .
%{__rm} -f Makefile
%{__cp} -a %{SOURCE15} Makefile
echo "override %{kmod_name} * weak-updates/%{kmod_name}" > kmod-%{kmod_name}.conf
%{__cat} <<EOF > blacklist-Broadcom.conf
blacklist b43
blacklist b43legacy
blacklist bcm43xx
blacklist ssb
EOF

%build
KSRC=%{_usrsrc}/kernels/%{kversion}
%{__make} -C "${KSRC}" %{?_smp_mflags} modules M=$PWD

%install
export INSTALL_MOD_PATH=%{buildroot}
export INSTALL_MOD_DIR=extra/%{kmod_name}
KSRC=%{_usrsrc}/kernels/%{kversion}
%{__make} -C "${KSRC}" modules_install M=$PWD
%{__install} -d %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} kmod-%{kmod_name}.conf %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} -d %{buildroot}%{_sysconfdir}/modprobe.d/
%{__install} blacklist-Broadcom.conf %{buildroot}%{_sysconfdir}/modprobe.d/
%{__install} -d %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
%{__install} lib/LICENSE.txt %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
%{__install} README.txt %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
# Set the module(s) to be executable, so that they will be stripped when packaged.
find %{buildroot} -type f -name \*.ko -exec %{__chmod} u+x \{\} \;
# Remove the unrequired files.
%{__rm} -f %{buildroot}/lib/modules/%{kversion}/modules.*

%clean
%{__rm} -rf %{buildroot}

%changelog
* Thu Oct 27 2011 The Doctor <DrWho@Gallifrey.Kasterborus> - 5_100_82_112-1
- Updated to use the 5_100_82_112 tarballs.
- Blacklisted the bcm43xx module.

* Fri Jul 08 2011 The Doctor <DrWho@Gallifrey.Kasterborus> - 5_100_82_38-3
- Hard-coded a ".el6" as part of the %{release} tag.

* Wed Jun 01 2011 The Doctor <DrWho@Gallifrey.Kasterborus> - 5_100_82_38-2
- Allow building for the currently running kernel, by default.
- Blacklist the interfering modules.

* Tue May 31 2011 The Doctor <DrWho@Gallifrey.Kasterborus> - 5_100_82_38-1
- Initial el6 build of the kmod package.
